<?php



/* config */
$aConfig = array();
$aConfig['login'] = '';
$aConfig['password'] = 'urpassword';
$aConfig['id'] = 141405517; // id of user which playlist u want to download



$aConfig['add_to_itunes'] = true; // add files to itunes? if false, files will be only downloaded into folder ./download/<id>/
$aConfig['playlist_name'] = 'VK.Export'; // playlist name, which will be created in ur itunes lubrar

/* end config */


if (empty($aConfig['login'])) die("Open this file in notepad and fill login,password,id");


################# CLASSES AND FUNCTIONS ###################

ini_set('memory_limit','2000M');

define('PATH_ROOT',realpath(dirname(__FILE__)));

define("PATH_WWW",realpath(dirname(__FILE__)));

define("PATH_TMP",PATH_WWW.'/tmp/');

set_include_path (
PATH_ROOT.  PATH_SEPARATOR .
PATH_WWW.  PATH_SEPARATOR .
PATH_TMP.  PATH_SEPARATOR .
get_include_path()
);


class Curl extends Logging {


	// instance object
	static private $instance = NULL;

	/**
	 * Instance of object
	 *
	 * @return Curl
	 */
	public static function getInstance()   {

		if (self::$instance == NULL) {
			$c = __CLASS__;
			self::$instance = new $c;
		}
		return self::$instance;
	}

	const NGINX_BLANK_STRLEN = 151;

	private $curl_timeout = 15;

	private $logging = false;

	private $curl_path;

	public function __construct() {

		parent::__construct();

		if (defined("PATH_TMP") && is_dir(PATH_TMP)) {
			$this->curl_path = PATH_TMP;
		}
		else {
			$this->curl_path = dirname(__FILE__);
		}
	}

	/**
	 * Returning integer Content Length. else => false
	 * @param string $sURL
	 */
	public function Ping($sURL,&$sRes='',&$iHTTPCODE='') {
		$bLog = $this->logging;
		if ($bLog) $this->Log('<HR>PING: '.$sURL."<BR>","/_curl.html");
		$ch = curl_init($sURL);
		curl_setopt($ch, CURLOPT_NOBODY, 1);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);
		curl_setopt($ch, CURLOPT_HEADER, 1);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_TIMEOUT, $this->_getCurlTimeOut());
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $this->_getCurlTimeOut());
		$sRes = curl_exec ($ch);
		$aINFO = curl_getinfo($ch);
		$iHTTPCODE = $aINFO['http_code'];
		$retcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		curl_close($ch);
		unset($ch);
		if (preg_match("/Content-Length:(.*?)\n/si",$sRes,$aMatchLength) || preg_match("/Content-Type:(.*?)\n/si",$sRes,$aMatchType)) {
			if (!empty($aMatchLength[1])) {
				$iContentLength = (int)trim($aMatchLength[1]);
				if ($iContentLength == self::NGINX_BLANK_STRLEN) return false;
				return $iContentLength;
			}
			elseif (!empty($aMatchType[1])) {
				return 1;
			}
		}
		else {
			return false;
		}
	}


	public function GetURL($sURL,$sReferer='',$sProxy = '',&$iHTTPCODE = 0,$aPostFields=array(),&$aCurlInfo=array(),$bFolLocation=false) {
		$ch = curl_init();
		static $iTries = 0;
		$bLog = $this->logging;
		if (empty($sURL)) die("CURL CURL NO URL :D");
		curl_setopt($ch, CURLOPT_URL, $sURL);
		if ($bLog) $this->Log('<HR>'.$sURL."<BR>","/_curl.html");
		if (ini_get('open_basedir') == '' && (ini_get('safe_mode') == '' || ini_get('safe_mode') == 'Off')) {
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		}
		else {
			if ($bFolLocation != true) {
				return $this->GetURL($sURL,$sReferer,$sProxy,$iHTTPCODE,$aPostFields,$aCurlInfo,true);
			}
		}
		$aHeaders[0] = "Accept: text/xml,application/xml,application/xhtml+xml,";
		$aHeaders[0].= "text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5";
		$aHeaders[] = "Accept-Charset: windows-1251,utf-8;q=0.7,*;q=0.7";
		$aHeaders[] = "Accept-Language: en-us,en;q=0.5";
		$aHeaders[] = "Cache-Control: no-cache, must-revalidatee";
		$aHeaders[] = "Connection: keep-alive";
		$aHeaders[] = "Keep-Alive: 115";
		$aHeaders[] = "Pragma: no-cache";
		$aAgents[] = 'Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.6; ru; rv:1.9.1.5) Gecko/20091102 Firefox/3.5.5 YB/3.5.1';
		$aAgents[] = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0.50727) YB/3.5.1';
		$aAgents[] = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0.50728) YB/3.5.1';
		$aAgents[] = 'Mozilla/5.0 (Macintosh; U; YB/3.5.1 ; Intel Mac OS X 10_6_2; en-us) AppleWebKit/531.21.8 (KHTML, like Gecko) Version/4.0.4 Safari/531.21.10';
		$aAgents[] = 'Mozilla/5.0 (Macintosh; U; YB/3.5.1 ; Intel Mac OS X 10_6_2; en-us) AppleWebKit/531.21.8 (KHTML, like Gecko) Version/4.0.5 Safari/531.5.4';
		$aAgents[] = 'Mozilla/5.0 (compatible; aiHitBot/1.0; +http://www.aihit.com/)';
		$aAgents[] = 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.2.1; aggregator:Spinn3r (Spinn3r 3.1); http://spinn3r.com/robot) Gecko/20021130';

		$aRefs = array();
		$aRefs[] = 'http://www.yandex.ru';
		$aRefs[] = 'http://forum.searchengines.ru/showthread.php?t='.rand(1134,2130982);
		curl_setopt($ch, CURLOPT_USERAGENT, $aAgents[rand(0,count($aAgents)-1)]);
		curl_setopt($ch, CURLOPT_HEADER, 1);
		curl_setopt($ch, CURLOPT_REFERER, $aRefs[rand(0,count($aRefs)-1)]);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$aHost = parse_url($sURL);
		curl_setopt($ch, CURLOPT_COOKIEJAR, $this->_getCookieFileName($aHost));
		curl_setopt($ch, CURLOPT_COOKIEFILE, $this->_getCookieFileName($aHost));
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

		if (!empty($aPostFields)) {
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $aPostFields);
		}
		curl_setopt($ch, CURLOPT_HTTPHEADER, $aHeaders);
		if (!empty($sProxy)) {
			if ($bLog) $this->Log(" [ <font color=blue>GET_URL</font> ] Starting use proxy {$sProxy}");
			curl_setopt($ch, CURLOPT_PROXY, "$sProxy");
			curl_setopt($ch, CURLOPT_TIMEOUT, $this->__getProxyTimeOut());
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $this->__getProxyTimeOut());
		}
		else {
			if ($bLog){
				$this->Log($sURL."<BR>\n");
				$this->Log("CURL TIMEOUT NOW IS : ".$this->_getCurlTimeOut()."<BR>\n","/_curl.html");
			}
			curl_setopt($ch, CURLOPT_TIMEOUT, $this->_getCurlTimeOut());
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $this->_getCurlTimeOut());
		}
		$sResponseFull = $sResponse = curl_exec ($ch);
		$sHeaders = substr($sResponse, 0, curl_getinfo($ch, CURLINFO_HEADER_SIZE));
		$sResponse = substr($sResponse, curl_getinfo($ch, CURLINFO_HEADER_SIZE));
		$aInfo = (curl_getinfo($ch));
		$iHTTPCODE = $aInfo['http_code'];
		if (empty($sProxy) && (int)curl_errno($ch) == 28) {
			if ($iTries>3) {
				$this->Log("CURL TIMEOUT ON FOUR TIME!! Skipping current URL: $sURL","/_curl.html");
				return false;
			}
			$iTries++;
			$iNewTimeout = $this->_getCurlTimeOut()*2;
			$this->_setCurlTimeOut($iNewTimeout);
			if ($bLog) $this->Log("CURL TIMEOUT! TRY AGAIN WITH NEW TIMEOUT: $iNewTimeout<BR>","/_curl.html");
			return $this->GetURL($sURL,$sReferer,$sProxy,$iHTTPCODE,$aPostFields,$aCurlInfoRedir,true);
		}


		if ($bFolLocation == true &&  ($iHTTPCODE == 301 || $iHTTPCODE == 302) )	{
			$iTries++;
			if ($iTries>5) {
				$this->Log("Permanent redirections. URL: $sURL. Returning sResponse<BR>","/_curl.html");
				$iTries = 0;
				return $sResponse;
			}
			$matches = array();
			preg_match('/Location:(.*?)\n/', $sHeaders, $matches);
			$url = @parse_url(trim(array_pop($matches)));
			if (!$url) {
				$iTries = 0;
				return $sResponse;
			}
			$last_url = parse_url(curl_getinfo($ch, CURLINFO_EFFECTIVE_URL));
			if (empty($url['scheme'])) $url['scheme'] = $last_url['scheme'];
			if (empty($url['host'])) $url['host'] = $last_url['host'];
			if (empty($url['path']) && !empty($last_url['path'])) $url['path'] = $last_url['path'];
			$new_url = $url['scheme'] . '://' . $url['host'] . (!empty($url['path']) ? $url['path'] : "") . (!empty($url['query'])?'?'.$url['query']:'');
			$this->Log("FOLLOW REDIRECT FROM LOCATION. NEW URL: {$new_url} <BR>\n","/_curl.html");
			$sResp = $this->GetURL($new_url,$sReferer,$sProxy,$iHTTPCODE,$aPostFields,$aCurlInfoRedir,true);
			$aCurlInfo = $aCurlInfoRedir;
			if ($bLog) $this->Log("GOT RESPONSE. STRLEN: ".strlen($sResponse).". HEADER STRLEN:".strlen($sHeaders)."<BR>","/_curl.html");
			return $sResp;
		}
		$aCurlInfo = $aInfo;
		ob_start();
		var_dump($sResponse);
		$sResp = ob_get_clean();
		curl_close ($ch);
		unset($ch);
		$this->_setCurlTimeOut(5);;
		if ($bLog) $this->Log("GOT RESPONSE. STRLEN: ".strlen($sResponse).". HEADER STRLEN:".strlen($sHeaders)." <BR>","/_curl.html");
		return $sResponse;
	}
	protected function _getCurlTimeOut() {
		return $this->curl_timeout;
	}
	public function setTimeOut($i) {
		$this->curl_timeout = $i;
	}
	protected function _setCurlTimeOut($i) {
		$this->curl_timeout = $i;
	}
	protected function _getCookieFileName($aHostData) {
		if (!empty($aHostData)) $sPostfix = '_'.$aHostData['host'];
		else $sPostfix = '';
		$sDir = $this->curl_path.'/curl_cookie';
		if (false == is_dir($sDir)) {
			@mkdir($sDir,755,1);
			Tools::ChmodX($sDir);
		}
		return $sDir.'/cookie'.$sPostfix.'.txt';
	}
	private function __getProxyTimeOut() {
		return 30;
	}
	public function clearCookie($aHostData) {
		@unlink($this->_getCookieFileName($aHostData));
	}
	public function __call($sMethod,$aParams) {
		$e = new Exception();
		error_log($e->getTraceAsString());
	}
}



class Backgrounder  {
	static $folder = './tmp/';
	static $db_name = 'whereis.dat';
	static $db = array();
	public static function fixRequest() {
		if (empty($_SERVER['argv'])) return;
		$aData = $_SERVER['argv'];
		array_shift($aData);
		$aRequest = array();
		foreach ($aData as $sVal) {
			if (false !== strpos($sVal,"=")) {
				list($sKey,$sValue) = explode("=",$sVal);
				$aRequest[$sKey]=$sValue;
			}
			else $aRequest[] = $sVal;
		}
		$_GET = $_REQUEST = $aRequest;
	}

	private static function __getWhereIsData() {
		if (!empty(self::$db)) return self::$db;
		$sFile = self::$folder.self::$db_name;
		if (file_exists($sFile)) {
			self::$db =  unserialize(base64_decode(file_get_contents($sFile)));
		}
		return self::$db;

	}

	private static function __saveWhereis($sBinName,$sPath) {
		$aData = self::__getWhereIsData();
		$aData[$sBinName] = $sPath;
		if (!is_dir(self::$folder)) mkdir(self::$folder,755,1);
		$sFile = self::$folder.self::$db_name;
		$sString = base64_encode(serialize($aData));
		self::$db = $aData;
		file_put_contents($sFile,$sString);
	}

	private static function __getFromDB($sBinName) {
		$aData = self::__getWhereIsData();
		if(isset($aData[$sBinName])) return $aData[$sBinName];
		else return false;
	}

	public static function whereIs($sBinName) {
		$sCmd = "/usr/bin/whereis {$sBinName}";
		$sPath = '';
		if ($sPath = self::__getFromDB($sBinName)) {
			return $sPath;
		}
		exec($sCmd,$a,$iError);
		if (!empty($a)) {
			if(false !== stripos($a[0],':')) {
				$aTmp = explode(" ",$a[0]);
				self::__saveWhereis($sBinName,$aTmp[1]);
				$sPath = $aTmp[1];
			}
			else {
				self::__saveWhereis($sBinName,$a[0]);
				$sPath = $a[0];
			}
		}
		else {
			exec("find /usr -name '$sBinName' -type f | find /opt -name '$sBinName' -type f ",$a,$b);
			if (empty($a)) return false;
			self::__saveWhereis($sBinName,$a[0]);
			$sPath = $a[0];
		}
		return $sPath;

	}

	private static function __genConsoleQuery($sQuery) {
		if (substr($sQuery,0,1) == '?') $sQuery = substr($sQuery,1);
		$aData = explode("&",$sQuery);
		$sConsoleQuery = '';
		foreach ($aData as $sArg) {
			$sConsoleQuery .= ' '.$sArg;
		}
		return $sConsoleQuery;
	}

	public static function Exec($sCmd) {
		exec($sCmd . " > /dev/null &");
	}

	public static function Run($sFileName,$sQuery) {
		if (false == file_exists($sFileName)) die ("No file");
		$sQuery = self::__genConsoleQuery($sQuery);
		if (strtoupper (substr(PHP_OS, 0,3)) == 'WIN') {
			$WshShell = new COM("WScript.Shell");
			$sCmd = "C:\WebServers\usr\bin\php.exe  \"$sFileName $sQuery\"";
			$oExec = $WshShell->Run($sCmd, 0, false);
		}
		else {
			$sPHPBin = '/usr/bin/php';
			$sCmd = "{$sPHPBin} {$sFileName} {$sQuery} > /dev/null 2>&1 &";
			exec($sCmd);
		}

	}
}



class Logging  {

	// instance object
	static private $instance = NULL;

	/**
	 * Instance of object
	 *
	 * @return Logging
	 */
	public static function getInstance()   {

		if (self::$instance == NULL) {
			$c = __CLASS__;
			self::$instance = new $c;
		}
		return self::$instance;
	}

	private $path = '';

	protected $logfile = '/_log.html';

	public function getCurrentLog() {
		return $this->logfile;
	}

	private function __createDir() {
		if (defined("PATH_WWW") && is_dir(PATH_WWW)) {
			$this->path = PATH_WWW;
		}
		else {
			$this->path = $_SERVER['DOCUMENT_ROOT'];
		}

		$this->path .= '/logs/';

		if (!is_dir($this->path)) {
			@mkdir($this->path,755,1);
			chmod($this->path, 0755);
			exec("/bin/chmod 755 {$this->path}");
		}
	}

	public function __construct() {
		$this->__createDir();
	}

	protected function _clearLog($bNoAutoRefresh = false) {
		$this->__createDir();
		file_put_contents($this->path.$this->logfile,"<html><head><title>VKParser update log</title>".($bNoAutoRefresh == false ? "<META HTTP-EQUIV='Refresh' CONTENT=3>" : "")."<style>body{padding:10px;margin:0px;font-family:arial;font-size:13px;}</style></head><body><PRE>");
	}
	public function clearLog() {
		$this->_clearLog();
	}


	protected function _setLogFileName($sName) {
		$this->logfile = $sName;
	}

	public function setLogFile($sName) {
		$this->_setLogFileName($sName);
	}

	public function Log($sMess,$sAltLogFile='') {
		$this->__createDir();
		//				echo $sMess.'<BR>';
		$this->mess[] = $sMess;

		if (!empty($sAltLogFile)) $sFileName = $sAltLogFile;
		else $sFileName = $this->logfile;

		error_log($sMess,3,$this->path.DIRECTORY_SEPARATOR.$sFileName);
		return $sMess;
	}

}



class Tools  {
	static private $time;

	public static function GenTimeStart() {
		self::$time =  microtime(true);
	}

	public static function GenTimeGet() {
		return round((microtime(true))-self::$time,4);
	}

	public static function Truncate($sString, $iLength = 80, $bBreakWords = false, $sEtc = '...')
	{
		if ($iLength == 0) return '';

		if (strlen($sString) > $iLength) {
			$iLength -= strlen($sEtc);
			if (!$bBreakWords) {
				$sString = preg_replace('/\s+?(\S+)?$/', '', substr($sString, 0, $iLength+1));
			}
			return substr($sString, 0, $iLength).$sEtc;
		} else return $sString;
	}

	public static function ChmodX($sDir) {
		if (false == is_dir($sDir)) return -1;
		chmod($sDir, 0755);
		exec("/bin/chmod 755 {$sDir}");
	}

	public static function searchDomain($sString) {
		$sPat = '/([-0-9a-zA-Z]+[.])+[a-zA-Z]{2,6}/si';

		if (preg_match($sPat,$sString,$aFound)) {
			return $aFound[0];
		}
		else return '';
		return $sDomain;
	}


	public static function stripWWW(&$sString) {
		if (0 === stripos($sString,"www.")) { // www. in start of string.
			$sString = substr($sString,4);
		}
		return $sString;
	}
	public static function stripHTTP(&$sString) {
		if (0 === stripos($sString,"http://")) { // www. in start of string.
			$sString = substr($sString,7);
		}
		return $sString;
	}

	private static function code2utf($num)
	{
		if ($num < 128) return chr($num);
		if ($num < 2048) return chr(($num >> 6) + 192) . chr(($num & 63) + 128);
		if ($num < 65536) return chr(($num >> 12) + 224) . chr((($num >> 6) & 63) + 128) . chr(($num & 63) + 128);
		if ($num < 2097152) return chr(($num >> 18) + 240) . chr((($num >> 12) & 63) + 128) . chr((($num >> 6) & 63) + 128) . chr(($num & 63) + 128);
		return '';
	}

	public static function unhtmlentities ($string) {
		static $trans_tbl;
		// replace numeric entities
		$string = preg_replace('~&#x([0-9a-f]+);~ei', 'self::code2utf(hexdec("\\1"))', $string);
		$string = preg_replace('~&#([0-9]+);~e', 'self::code2utf(\\1)', $string);
		// replace literal entities
		if (!isset($trans_tbl))
		{
			$trans_tbl = array();
			foreach (get_html_translation_table(HTML_ENTITIES) as $val=>$key)
			$trans_tbl[$key] = utf8_encode($val);
		}

		return strtr($string, $trans_tbl);
	}
	public static function translit($st) {
		// $str - UTF-8 on enter.
		// Сначала заменяем "односимвольные" фонемы.
		$st=strtr($st,"абвгдеёзийклмнопрстуфхъыэ_","abvgdeeziyklmnoprstufh'iei");
		$st=strtr($st,"АБВГДЕЁЗИЙКЛМНОПРСТУФХЪЫЭ_","ABVGDEEZIYKLMNOPRSTUFH'IEI");
		// Затем - "многосимвольные".
		$st=strtr($st,
		array("ж"=>"j", "ц"=>"ts", "ч"=>"ch", "ш"=>"sh",
              "щ"=>"shch","ь"=>"", "ю"=>"yu", "я"=>"ya",
              "Ж"=>"J", "Ц"=>"TS", "Ч"=>"CH", "Ш"=>"SH", 
              "Щ"=>"SHCH","Ь"=>"", "Ю"=>"YU", "Я"=>"YA",
              "ї"=>"i", "Ї"=>"Yi", "є"=>"ie", "Є"=>"Ye")
		);
		return $st;
	}
	public static function bytesFormat($size) {
		$units = array(' B', ' KB', ' MB', ' GB', ' TB');
		for ($i = 0; $size >= 1024 && $i < 4; $i++) $size /= 1024;
		return round($size, 2).$units[$i];
	}



}



class iTunes extends Logging {
	// instance object
	static private $instance = NULL;
	/**
	 * Instance of object
	 *
	 * @return iTunes
	 */
	public static function getInstance()   {
		if (self::$instance == NULL) {
			$c = __CLASS__;
			self::$instance = new $c;
		}
		return self::$instance;
	}

	private $playlist_name = "Vkontakte Export";

	public function setPlayListName($sString) {
		$this->playlist_name = $sString;
	}
	public function getPlayListName() {
		return OSAScript::EscapeSingleQuote($this->playlist_name);
	}
	public function CreatePlaylist() {
		static $sPlayListName = '';
		if (!empty($sPlayListName)) return $sPlayListName;
		$sBin = Backgrounder::whereIs('osascript');
		$sPlayListName = $this->getPlayListName();
		$sScript = '
			tell application "iTunes"
				if (playlist ("'.$sPlayListName.'") exists) is false then
				make new user playlist with properties {name:"'.$sPlayListName.'"}
				end if
			end tell';
		$sQuery = OSAScript::Compile($sScript);
		$sCmd = $sBin.' '.$sQuery;
		exec($sCmd,$a,$b);
		if (!empty($a[0])) {
			$this->Log("Playlist created<BR>");
		}
		return $sPlayListName;
	}

	public function ConvertID3Tags($sFileName) {
		$sTmpName = dirname($sFileName).DIRECTORY_SEPARATOR.md5($sFileName).'.mp3';
		rename($sFileName,$sTmpName);
		$sBin = Backgrounder::whereIs('find');

		$sMid3iconvBin = '/opt/local/bin/mid3iconv';
		if (file_exists($sMid3iconvBin)) {
			$this->Log("Converting track ID3v2 tags to UTF-8 : ".iconv("UTF-8","WINDOWS-1251",basename($sFileName))."<BR>");
			$sCmd = $sBin.' '.dirname($sFileName).' -name "'.basename($sTmpName).'" -print0 | xargs -0 '.$sMid3iconvBin.' -e CP1251 -d';
			exec($sCmd,$a,$b);
		}
		else {
			$this->Log("Converting binary `mid3iconv` from library py-mutagen not found. Track convering skipped<BR>");
		}
		rename($sTmpName,$sFileName);
	}

	public function addSong($sFileName,$sPlayListName='') {
		if (empty($sPlayListName)) $sPlayListName = $this->CreatePlaylist();
		$this->ConvertID3Tags($sFileName);
		$this->Log("Adding song: ".iconv("UTF-8","WINDOWS-1251",basename($sFileName)).'...');
		if (false == file_exists($sFileName)) {
			echo "File `$sFileName` does not exist<BR>";
			continue;
		}
		$sScript = '
			tell application "iTunes"
				set MyPlayList to "'.$sPlayListName.'"
				add POSIX file "'.$sFileName.'" to playlist MyPlayList
			end tell
			';
		$sQuery = OSAScript::Compile($sScript);
		$sBin = Backgrounder::whereIs('osascript');
		$sCmd = $sBin.' '.$sQuery;
		$z = exec ($sCmd,$a,$b);
		$this->Log("Done.<BR>");
	}

	public function AddSongs($aData) {
		$sPlayListName = $this->CreatePlaylist();
		foreach ($aData as $sFileName) {
			$this->addSong($sFileName,$sPlayListName);
		}
	}
}












class OSAScript  {

	// instance object
	static private $instance = NULL;

	/**
	 * Instance of object
	 *
	 * @return OSAScript
	 */
	public static function getInstance()   {

		if (self::$instance == NULL) {
			$c = __CLASS__;
			self::$instance = new $c;
		}
		return self::$instance;
	}

	const COMMAND_QUOTE = "'";
	const VARIABLE_QUOTE = '"';

	static public function Compile($sString) {
		$aRows = explode("\n",$sString);
		foreach ($aRows as &$sRow) {
			$sRow = trim($sRow);
			if (empty($sRow)) continue;
			$sRow = str_ireplace(self::COMMAND_QUOTE,'" & ASCII character (39) &  "',$sRow); // single quote escape
			$sRow = '-e '.self::COMMAND_QUOTE.$sRow.self::COMMAND_QUOTE;
		}
		$sCompile = implode(" ",$aRows);
		return $sCompile;
	}

	static public function EscapeSingleQuote($sString) {
		return str_ireplace(self::COMMAND_QUOTE,'" & ASCII character (39) &  "',$sString);
	}
}





class VKParser extends Logging {


	// instance object
	static private $instance = NULL;

	/**
	 * Instance of object
	 *
	 * @return VKParser
	 */
	public static function getInstance()   {

		if (self::$instance == NULL) {
			$c = __CLASS__;
			self::$instance = new $c;
		}
		return self::$instance;
	}

	//	http://vkontakte.ru/editapp?id=2417389		flash
	//	http://vkontakte.ru/editapp?id=2417560 		desktop


	const AUTH_URL = "http://login.vk.com/?act=login";

	private $dest_dir = '';

	private $access = array();

	private $curl;

	private $iTunes;

	private $db;



	public function __construct() {

		$this->curl = Curl::getInstance();

		$this->iTunes = iTunes::getInstance();

	}


	public function setLogin($sString) {
		$this->access['login'] = $sString;
	}

	public function setPassword($sString) {
		$this->access['password'] = $sString;
	}
	public function setPlaylistUserID($sString) {
		$this->access['id'] = (int)$sString;
	}

	public function getAudioList() {
		if (empty($this->access['login'])) die("Login not set in getAudio");
		if (empty($this->access['password'])) die("Password not set in getAudio");
		if (empty($this->access['id'])) die("User ID not set in getAudio");
		$user_agent = 'Mozilla/5.0 (Windows; U; Windows NT 6.0; ru; rv:1.9.2.13) ' .
            'Gecko/20101203 Firefox/3.6.13 ( .NET CLR 3.5.30729)';
		$cookie = '';
		$login = $this->access['login'];
		$password = $this->access['password'];
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_USERAGENT, $user_agent);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_TIMEOUT, 10);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($ch, CURLOPT_URL, 'http://login.vk.com/?act=login');
		$post = array(
            'act' => 'login',
            'q' => '',
            'al_frame' => '1',
            'expire' => '',
            'captcha_sid' => '',
            'captcha_key' => '',
            'from_host' => 'vkontakte.ru',
            'email' => $login,
            'pass' => $password
		);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($post));
		$answer = curl_exec($ch);
		$sid = substr($answer, strpos($answer, "setCookieEx('sid', '") + 20, 60);
		$cookie = 'remixsid=' . $sid;
		curl_setopt($ch, CURLOPT_COOKIE, $cookie);
		curl_setopt($ch, CURLOPT_COOKIEJAR, './cookie.txt');
		curl_setopt($ch, CURLOPT_COOKIEFILE, './cookie.txt');
		curl_setopt($ch, CURLOPT_URL, 'http://vkontakte.ru/audio');
		$aPostFields = array();
		$aPostFields['act'] = 'load_audios_silent';
		$aPostFields['al'] = '1';
		$aPostFields['edit'] = '0';
		$aPostFields['gid'] = '0';
		$aPostFields['id'] = $this->access['id'] ;

		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $aPostFields);

		$sData = curl_exec($ch);

		curl_close($ch);

		$sData = (substr($sData,stripos($sData,"{")));
		$sData = (substr($sData,0,stripos($sData,"}")+1));
		$sData = str_ireplace("'",'"',$sData);
		$aData = json_decode(iconv("WINDOWS-1251","UTF-8",$sData));

		$aData  = (array)$aData;
		$aData = $aData['all'];
		foreach ($aData as $aFields) {
			$aSong = array();
			$aSong['author'] = iconv("UTF-8","WINDOWS-1251",$aFields[5]);
			$aSong['title'] = iconv("UTF-8","WINDOWS-1251",$aFields[6]);
			$aSong['album_id'] = $aFields[8];;
			$aSong['link'] = $aFields[2];;
			$aSongs[] = $aSong;
		}
		return $aSongs;
	}

	public function getDestDir() {
		$sDir =  $this->dest_dir = PATH_WWW.DIRECTORY_SEPARATOR.'downloads'.DIRECTORY_SEPARATOR.$this->access['id'].DIRECTORY_SEPARATOR;
		@mkdir($sDir,0755,1);
		Tools::ChmodX($sDir);
		return $sDir;
	}

	public function EscapeChars($sFileName) {
		$sFileName = str_ireplace("/","\\\\",$sFileName);
		return $sFileName;
	}

	public function DownloadSongs($aSongs) {
		$sDstDir = $this->getDestDir();
		if (empty($aSongs)) return array();
		$iTotal = count($aSongs);
		$this->Log("Start download songs. Total:".$iTotal."<BR>");
		$aReturn = array();
		$i=0;
		foreach ($aSongs as $aRow) {
			$i++;
			if (empty($aRow['link'])) continue;
			$sURL = $aRow['link'];

			$aRow['title'] = ucfirst(strtolower($aRow['title']));
			$aRow['author'] = ucfirst(strtolower($aRow['author']));

			$sFileName = $aRow['author'].' - '.$aRow['title'];
			$sFileName = htmlspecialchars_decode($sFileName,ENT_QUOTES);
			$sFileName = html_entity_decode($sFileName);
			$sFileName = substr($sFileName,0,150).'.mp3';

			$sFileName = $this->EscapeChars($sFileName);
			$sFullFileNameDst = $sDstDir.DIRECTORY_SEPARATOR.iconv("WINDOWS-1251","UTF-8",$sFileName); // for system filename
			$aReturn[] = $sFullFileName = $sDstDir.DIRECTORY_SEPARATOR.$sFileName;
			$this->Log("[$i/$iTotal] Downloading song :".$sFileName."...");
			if (file_exists($sFullFileNameDst)) {
				$this->Log("already downloaded<BR>");
				continue;
			}
			$this->curl->setTimeOut(5*60); // 5 min;
			$sContent = $this->curl->GetURL($sURL);
			if (false !== stripos($sContent,"<html>")) {
				$this->Log("Download error. 404 retutned. Try again after few mins<BR>");
				continue;
			}
			$this->Log("Done<BR>");
			file_put_contents($sFullFileNameDst,$sContent);
			$this->iTunes->addSong($sFullFileNameDst);
		}

		$this->Log("Downloading complited<BR>");

		return $aReturn;
	}


	public function Run() {
		$aSongs = $this->getAudioList();
		return $this->DownloadSongs($aSongs);

	}
}



class Kernel {
	static public function Run($aConfig) {
		empty($aConfig) ? die("\$aConfig is empty") : "";
		empty($aConfig['login']) ? die("Login not set in \$aConfig['login']") : "";
		empty($aConfig['password']) ? die("Password not set in \$aConfig['password']") : "";
		empty($aConfig['id']) ? die("UserID not set in \$aConfig['id']") : "";
		Logging::getInstance()->clearLog();
		$VK = VKParser::getInstance();
		$VK->setLogin($aConfig['login'] );
		$VK->setPassword($aConfig['password']);
		$VK->setPlaylistUserID($aConfig['id']);
		if (!empty($aConfig['playlist_name'])) {
			iTunes::getInstance()->setPlayListName($aConfig['playlist_name']);
		}
		$aSongs = $VK->Run();
	}
}







################# MAIN MODULE ###################


//////// start
Kernel::Run($aConfig);
